;	---------------------------------------
;	Test-Projekt: 
;	---------------------------------------

.include "m32def.inc"					;Definitionsdatei laden
.cseg									;Beginn eines Code-Segmentes
.org 0x0000								;Startadresse=0
	rjmp	start

.equ sys_clock		= 8000000

start:
	ldi		r16,LOW(RAMEND)				;Stackpointer (low) auf
	out		spl,r16						;RAM-Ende setzen
	ldi		r16,HIGH(RAMEND)			;Stackpointer (high) auf
	out		sph,r16						;RAM-Ende setzen

	rcall	blink_init

loop:
	rcall	wait
	rcall	wait
	rcall	blink_toggle
	rjmp	loop

;
;	Warteschleife
;
wait:
	push	r17
	push	r18
	push	r19
	ldi		r19,20					;r19, r18 und r17
	clr		r18						;ergeben zusammen
	clr		r17						;einen 3-Byte-Zhler
wait1:
	dec		r17						;niedrigstes Byte -1
	brne	wait1					;0 erreicht? nein -> Schleife
	dec		r18						;mittleres Byte -1
	brne	wait1					;0 erreicht? nein -> Schleife
	dec		r19						;hchstes Byte -1
	brne	wait1					;0 erreicht? nein -> Schleife
	pop		r19
	pop		r18
	pop		r17
	ret								;Schleifenende, Rckkehr

;8MHz = 1 Takt = 125ns
;1us = 8 Takte
;1ms = 8000
;1s  = 8000000 Takte
;(rcall = 3)
;takte = 3+6+3+r16*((256*2+1)*(256*2+1))*2+1+6+4
;zeit in ms = takte/8000
delay10s:
	push	r16
	push	r17
	push	r18
	ldi		r16,$99							;1 -> 10 Sekunden
	clr		r17								;1
	clr		r18								;1
dloop_sek:
	dec		r18								;1
	brne	dloop_sek						;1/2
	dec		r17								;1
	brne	dloop_sek						;1/2
	dec		r16								;1
	brne	dloop_sek						;1/2
	pop		r18
	pop		r17
	pop		r16
	ret										;4

.include "blink_led.asm"					;Test blinkende LED
